/*------------------------------------   Includes   ---------------------------------------------*/
#include "2D_bsp.h"
#include "display.h"
#include "draw_line.h"
#include "ddutil.h"

using namespace std;


std::ostream &operator<<(std::ostream &os, const cWall &ex) 
{ 
	return os << ex.p0 << "-->" << ex.p1; 
};



/****************************************************************************************************/
// class cWall
/****************************************************************************************************/
cWall::cWall()                                      
{ 
	p0 = cPoint2D(0,0); 
	p1 = cPoint2D(0,0); 
}

/*--------------------------------------------------------------------------------------------------*/
cWall::cWall(cWall& wall)                           
{ 
	p0=wall.p0;
	p1=wall.p1;
}
	
/*--------------------------------------------------------------------------------------------------*/
cWall::cWall( cPoint2D & A, cPoint2D & B)             
{ 
	p0=A; 
	p1=B;
}

/*--------------------------------------------------------------------------------------------------*/
BSP_POSITION_DIVIDER cWall::Get_Position_Divider_And_Split( cWall & w , cWall & w_front  , cWall & w_back ) 
{ 
	std::cout << "BSP_POSITION_DIVIDER cWall::Get_Position_Divider_And_Split( cWall & w , cWall & w_front  , cWall & w_back ) \n";
	std::cout << "NOT IMPLEMENTED !!!!!!\n";
	return DIVIDER_ON;
}	

/*--------------------------------------------------------------------------------------------------*/
double cWall::Get_Length() 
{ 
	return sqrt( (p0.Get_X()-p1.Get_X()) * (p0.Get_X()-p1.Get_X())
	    	   + (p0.Get_Y()-p1.Get_Y()) * (p0.Get_Y()-p1.Get_Y()) );
}
	

/*--------------------------------------------------------------------------------------------------*/
void cWall::Display(CDisplay * display)
{
	Draw_Line( display ,  p0,p1, 0x20 );
	
}

/*--------------------------------------------------------------------------------------------------*/
BSP_POSITION_DIVIDER cWall::Get_Position_Divider( cWall & w )
{
	BSP_POSITION_POINT pos0 = Get_Position_Point( w.p0) ;
	BSP_POSITION_POINT pos1 = Get_Position_Point( w.p1) ;

	switch( pos0)
	{
	case POINT_FRONT:
		switch(pos1)
		{
		case POINT_FRONT:
			return DIVIDER_FRONT;
		case POINT_BACK:
			return DIVIDER_CROSS;
		case POINT_ON:
			return DIVIDER_FRONT;
		default:
			cout << "ERROR : BSP_POSITION_DIVIDER cWall::Get_Position_Divider( cWall & w )";
			return DIVIDER_ON;  // pour eviter le warning "path without return"
		}
		break;
	case POINT_BACK:
		switch(pos1)
		{
		case POINT_FRONT:
			return DIVIDER_CROSS;
		case POINT_BACK:
			return DIVIDER_BACK;
		case POINT_ON:
			return DIVIDER_BACK;
		default:
			cout << "ERROR : BSP_POSITION_DIVIDER cWall::Get_Position_Divider( cWall & w )";
			return DIVIDER_ON;  // pour eviter le warning "path without return"
		}
		break;
	case POINT_ON:
		switch(pos1)
		{
		case POINT_FRONT:
			return DIVIDER_ON;
		case POINT_BACK:
			return DIVIDER_BACK;
		case POINT_ON:
			cout << "ERROR : BSP_POSITION_DIVIDER cWall::Get_Position_Divider( cWall & w )";
			cout << "les murs parallelles ne sont pas encore grs ! \n";			
			cout << "cWall :" << w << " et " << (*this) << " \n";
			return DIVIDER_ON;  // pour eviter le warning "path without return"
		default:
			cout << "ERROR : BSP_POSITION_DIVIDER cWall::Get_Position_Divider( cWall & w )";
			return DIVIDER_ON;  // pour eviter le warning "path without return"
		}
		break;
	default:
		cout << "ERROR : BSP_POSITION_DIVIDER cWall::Get_Position_Divider( cWall & w )";
			return DIVIDER_ON;  // pour eviter le warning "path without return"
	}
	
	
	
};


