#pragma warning(disable: 4786)
/*------------------------------------   Includes   ---------------------------------------------*/
#include "bsp_debug_X.h"
#include "draw_line.h"


#define COLOR_GRAPH               0x50
#define COLOR_CENTRE_TO_WALL      0xf0
#define COLOR_CENTRE_TO_PORTAL    0x12
#define COLOR_ROOMS_BOUNDS        0x08


/****************************************************************************************************/
// class cGame_World_Debug_Displayer
/****************************************************************************************************/
void cGame_World_Debug_Displayer::Display_Areas(CDisplay & display , cGame_World & world)
{
	// on parcours toutes les pieces pour les afficher
	std::vector<cSquare_Area*>::iterator Areas_Itr;
	for(Areas_Itr = world.List_Areas.begin() ; Areas_Itr != world.List_Areas.end() ; Areas_Itr++)
		Area_Displayer.Display(display, *(*Areas_Itr) );

}


/*--------------------------------------------------------------------------------------------------*/
void cGame_World_Debug_Displayer::Display_Graph(CDisplay & display , cGame_World & world)
{

	std::vector<cPortal*>::iterator portals_itr;
	cList_A_Star_Nodes::iterator voisins_itr;
	cList_A_Star_Nodes voisinage;
	// on parcours tous les portails
	for(portals_itr = world.List_Portals.begin() ; portals_itr != world.List_Portals.end() ; portals_itr++)	
	{
		// on trace un segment entre ce portail et son voisin
		(*portals_itr)->Get_List_Neighbors(voisinage);
		for( voisins_itr = voisinage.begin(); voisins_itr != voisinage.end() ; voisins_itr++)
		{
			Draw_Line( g_pDisplay , (*portals_itr)->Position , (*voisins_itr)->Position , COLOR_GRAPH );
		}
	}

}

/*--------------------------------------------------------------------------------------------------*/
void cSquare_Area_Debug_Displayer::Display(CDisplay & display , cSquare_Area & area)
{
	cHV_Seg cote;
	cPoint2D center;
	cPoint2D p;

	// affiche le contour de la piece
	area.Bounds.Get_Est_Seg(cote);
	Draw_Line( g_pDisplay ,cote.Get_p0(),cote.Get_p1(),COLOR_ROOMS_BOUNDS );
	
	area.Bounds.Get_Nord_Seg(cote);
	Draw_Line( g_pDisplay ,cote.Get_p0(),cote.Get_p1(),COLOR_ROOMS_BOUNDS );
	
	area.Bounds.Get_Ouest_Seg(cote);
	Draw_Line( g_pDisplay ,cote.Get_p0(),cote.Get_p1(),COLOR_ROOMS_BOUNDS );
	
	area.Bounds.Get_Sud_Seg(cote);
	Draw_Line( g_pDisplay ,cote.Get_p0(),cote.Get_p1(),COLOR_ROOMS_BOUNDS );

	area.Bounds.Get_Centre(center);
	
	// affiche une ligne entre le centre de la piece et chaque portal
	std::vector<cPortal*>::iterator portals_itr;	
	for( portals_itr = area.List_Portals.begin(); 	portals_itr != area.List_Portals.end(); portals_itr++)
	{	
		Draw_Line( g_pDisplay ,center,(*portals_itr)->Position,COLOR_CENTRE_TO_PORTAL );
	}

	// affiche une ligne entre le centre de la piece et chaque mur
	std::vector<cHV_Seg*>::iterator walls_itr;	
	for(walls_itr = area.List_Walls.begin() ; walls_itr != area.List_Walls.end() ; walls_itr++)
	{
		(*walls_itr)->Get_Middle(p);
		Draw_Line( g_pDisplay , center , p , COLOR_CENTRE_TO_WALL);
	}
}

