/***************************************************************************************************/
/***************************************************************************************************/
//! \file bsp_debug_X.h
//! \brief Declare les classes utiles pour afficher des informations de  debug concernant le bsp, a l'ecran
//!    
//!	Auteur : Adrien Auclair
//!
/***************************************************************************************************/
/***************************************************************************************************/
#ifndef BSP_DEBUG_X_H
#define BSP_DEBUG_X_H

class cGame_World_Debug_Displayer;
class cSquare_Area_Debug_Displayer;

#include "ddutil.h"
#include "game_bsp.h"




/*************************************************************************************************/
//! classe qui permet d'afficher des infos graphiques de debug sur une piece
/*************************************************************************************************/
class cSquare_Area_Debug_Displayer
{
public:
	/// affiche les infos de 'area' pour le debug, ds 'display'
	void Display(CDisplay & display , cSquare_Area & area);	
};


/*************************************************************************************************/
//! classe qui permet d'afficher des infos graphiques de debug sur un cGame_World
/*************************************************************************************************/
class cGame_World_Debug_Displayer
{
public:
	/// default constructor
	cGame_World_Debug_Displayer() {};

	/// affiche les areas de 'world' pour le debug, ds 'display'
	void Display_Areas(CDisplay & display , cGame_World & world);
	
	// affiche le graph de portals de 'world', pour le debug,ds 'display'
	// cad les noeuds voisins de chaque noeud
	void Display_Graph(CDisplay & display , cGame_World & world);
private:
	cSquare_Area_Debug_Displayer Area_Displayer;  ///< objet pour afficher une area
};



#endif