/***************************************************************************************************/
/***************************************************************************************************/
//! \file display.h
//! \brief Dfini les classes d'affichages
//!    
//!	Auteur : Adrien Auclair \n
//!
//! 
//! les sprites avec transparence sont blittes depuis g_pBitmap \n
//! ceux ss transparence sont pris ds g_pMessages
//!
/***************************************************************************************************/
/***************************************************************************************************/
#ifndef DISPLAY_H
#define DISPLAY_H

/*------------------------------------  Prototypes  ---------------------------------------------*/
class cAbstract_Display_Def;
class cSprite_Display_Def;
class cBitmap_Display_Def;


/*------------------------------------   Includes   ---------------------------------------------*/
#include "main.h"
#include "geo_utils.h"
#include "mydebug.h"



/*------------------------------------    Define    ---------------------------------------------*/
#define X_DISPLAY_BOMBS 545
#define Y_DISPLAY_BOMBS 500
#define TX_BOMB         30

#define X_DISPLAY_TELEPORTEURS 540
#define Y_DISPLAY_TELEPORTEURS 532
#define TX_TELEPORTEUR         30

#define X_DISPLAY_HOLOGRAMMES 625
#define Y_DISPLAY_HOLOGRAMMES 564
#define TX_HOLOGRAMME         30


/*-------------------------------------   Classes   ---------------------------------------------*/


/*************************************************************************************************/
//! classe gnrique d'affichage
/*************************************************************************************************/
class cAbtract_Display_Def
{
public:
	/// constructeur
	/**
	* bitmap : rectangle  blitter lors de l'affichage
	*/
	cAbtract_Display_Def( RECT & bitmap) {Bitmap_Rect = bitmap; };	

	/// fonction purement virtuelle
	virtual void Display(int x, int y) =0;

protected:	
	RECT Bitmap_Rect;    ///< zone  blitter lors de l'affichage
};


/*************************************************************************************************/
//! classe d'affichage des sprites ( avec cl de coleur transparente)
/*************************************************************************************************/
class cSprite_Display_Def : public cAbtract_Display_Def
{
public:
	/// constructeur
	/**
	* bitmap : rectangle  blitter lors de l'affichage
	*/
	cSprite_Display_Def( RECT & bitmap):cAbtract_Display_Def(bitmap) {};
	
	/// fait un blit avec cl de couleur transparente  partir de la surface g_pSprites dans le backbuffer
	void Display(int x, int y);
};

/*************************************************************************************************/
//! classe d'affichage des bitmaps ( pas de trasnparence )
/*************************************************************************************************/
class cBitmap_Display_Def : public cAbtract_Display_Def
{
public:
	/// constructeur
	/**
	* bitmap : rectangle  blitter lors de l'affichage
	*/
	cBitmap_Display_Def( RECT & bitmap):cAbtract_Display_Def(bitmap) {};
	
	/// fait un blit sans cl de couleur transparente  partir de la surface g_pMessages dans le backbuffer
	void Display(int x, int y);
};



#endif