#include "errrors_display.h"



#ifdef _WINDOWS

	#include "mydebug.h"
	#include <dxerr9.h>

	Debugger Fatal_Error ("fatal_error.txt");

	/*--------------------------------------------------------------------------------------------------*/
	void Display_Fatal_Error( HWND hWnd , const char * err_message)
	{
		Fatal_Error << err_message << "\n";
		MessageBox(hWnd ,err_message , "Fatal Error", MB_ICONERROR | MB_OK);		
	}

	/*--------------------------------------------------------------------------------------------------*/
	void Display_Fatal_Error( HWND hWnd , const char * err_message ,  HRESULT hr)
	{
		std::string error_message;
		error_message += err_message;  	
		error_message += "\n HR_RESULT : ";	  
		error_message += (char*)DXGetErrorDescription9(hr);
		Fatal_Error << error_message << "\n";
		MessageBox(hWnd ,error_message.c_str() , "Fatal Error", MB_ICONERROR | MB_OK);		
	}

#endif


#ifdef _CONSOLE


	/*--------------------------------------------------------------------------------------------------*/
	void Display_Fatal_Error( const char * err_message)
	{
		Fatal_Error << err_message << "\n";
		cout << "FATAL ERROR :" << err_message << "\n";

	}

	/*--------------------------------------------------------------------------------------------------*/
	void Display_Fatal_Error( const char * err_message ,  HRESULT hr)
	{
		std::string error_message;
		error_message += err_message;  	
		error_message += "\n HR_RESULT : ";	  
		error_message += (char*)DXGetErrorDescription9(hr);
		Fatal_Error << error_message << "\n";
		cout << "FATAL_ERROR : " << error_message.c_str() << "\n";
	}


#endif

