/***************************************************************************************************/
/***************************************************************************************************/
//! \file errrors_display.h
//! \brief Dfini les fonctions pour afficher un message d'erreur
//!    
//!	Auteur : Adrien Auclair
//!
//! Ces fonctions dependent si _WINDOWS ou _CONSOLE est dfini \n
//! ces fonctions ne font qu'affiche le message, elle ne quitte pas le programme 
/***************************************************************************************************/
/***************************************************************************************************/
#ifndef ERRORS_DISPLAY_H
#define ERRORS_DISPLAY_H

#include <windows.h>
#include <dxerr9.h>

#ifdef _WINDOWS
	/*--------------------------------------------------------------------------------------------------*/
	void Display_Fatal_Error( HWND hWnd , const char * err_message);

	/*--------------------------------------------------------------------------------------------------*/
	void Display_Fatal_Error( HWND hWnd , const char * err_message ,  HRESULT hr);
#endif


#ifdef _CONSOLE
	/*--------------------------------------------------------------------------------------------------*/
	void Display_Fatal_Error( const char * err_message);

	/*--------------------------------------------------------------------------------------------------*/
	void Display_Fatal_Error( const char * err_message ,  HRESULT hr);

#endif


#endif