/***************************************************************************************************/
/***************************************************************************************************/
//! \file mydebug.h
//! \brief declarre un objet de debug qui envoie les infos passes ds un fichier text
//!    
//!	Auteur : Adrien Auclair
//!
//! on peut rajouter a loisir tous les formats de donnes voulus
/***************************************************************************************************/
/***************************************************************************************************/
#ifndef MYDEBUG_H
#define MYDEBUG_H

/*------------------------------------  Prototypes  ---------------------------------------------*/
class Debugger;


/*------------------------------------   Includes   ---------------------------------------------*/
#include <iostream>
#include <string>
#include <windows.h>

#include "geo_utils.h"


/*-------------------------------------   Classes   ---------------------------------------------*/

/*************************************************************************************************/
//! gere un fichier de texte vers lequel on peut envoyer tte sorte de donnes
/*! on peut rajouter toute sorte de fonction friend pour envoyer ses donnes vers le fichier
**************************************************************************************************/
class Debugger
{
	friend Debugger& operator<<(Debugger&  , const char* );
	friend Debugger& operator<<(Debugger&  , int integer);
	friend Debugger& operator<<(Debugger&  , unsigned int uinteger);
	friend Debugger& operator<<(Debugger&  in, float flottant);
	friend Debugger& operator<<(Debugger&  in, DWORD);
	friend Debugger& operator<<(Debugger&  in, bool);
	friend Debugger& operator<<(Debugger&  in, char);
	friend Debugger& operator<<(Debugger&  in, HRESULT);
	friend Debugger& operator<<(Debugger&  in, cSeg&);
	friend Debugger& operator<<(Debugger&  in, cPoint2D&);
	friend Debugger& operator<<(Debugger&  in, std::string&);
	
	
	friend Debugger& operator<<(Debugger&  in, Debugger &right) {return in;};

public :
	/// param : name of the output file		
	Debugger(const char *);   
private :
	char *File_Name; 
};





#endif

