#pragma warning(disable: 4786)

/*------------------------------------   Includes   ---------------------------------------------*/
#include "player.h"
#include "game_manager.h"


/*------------------------------------    Define    ---------------------------------------------*/

#define NB_MAX_LIVES 4



/****************************************************************************************************/
// class cPlayer
/****************************************************************************************************/
cPlayer::cPlayer(int x, int y):cUnit(x,y,Game_Manager.pDisplay_White_Ball,SPEED_WHITE_BALL,RAYON_WHITE_BALL) 
{
	Nb_Bombs             = 1;	
	Nb_Teleporteurs      = 1;
	Nb_Hologrammes       = 1;
	Nb_Lives             = INITIAL_NB_LIVES;	
};

/*--------------------------------------------------------------------------------------------------*/
void cPlayer::React_To_Bomb(cBomb * bomb)
{
	assert( bomb != NULL);	
	
	//si  ce n'est pas la bombe que je viens de poser
	if( DXUtil_Timer( TIMER_GETAPPTIME ) - bomb->Time_Stamp > DELAY_BOMB) 
	{		
		Game_Manager.Try_Kill_Player();     // faire signe au game manager qu'il doit enlever une vie au game
		Game_Manager.Remove_Bonus(bomb);
	}
}

/*--------------------------------------------------------------------------------------------------*/
void cPlayer::React_To_Cadeau(cCadeau * cado)
{
	assert( cado != NULL);
	
	// selon ce que contient ce cadeau, on agit
	switch( cado->Get_Inside())
	{
	case CADEAU_TELEPORTEUR:
		if( Nb_Teleporteurs < NB_MAX_TELEPORTEURS)
			Nb_Teleporteurs++;
		break;
	case CADEAU_BOMB:
		if( Nb_Bombs < NB_MAX_BOMBS)
			Nb_Bombs++;		
		break;
	case CADEAU_HOLOGRAMME:
		if( Nb_Hologrammes < NB_MAX_HOLOGRAMMES)
			Nb_Hologrammes++;		
		break;
	case CADEAU_COEUR:
		if( Nb_Lives < NB_MAX_LIVES)
			Nb_Lives++;
		break;
	case CADEAU_POINTS:
		Game_Manager.Score += 10*(Game_Manager.Id_Level+1)*(Game_Manager.Id_Level+1);
		break;
	case CADEAU_TIME:
		// TODO
		break;
	default:
		assert(0);
		break;
	}

	Game_Manager.Bonus_Garbage_Collector.push_back( cado );	
}


/*--------------------------------------------------------------------------------------------------*/
void cPlayer::Use_Teleporteur()
{
	// si cette fonction est appelle, c qu'il y a un teleporteur sur la carte !!!
	assert( Game_Manager.bTeleporteur_In_Game);
	std::list<cInteractive_Item*>::iterator  bonus_itr;

	// cherche ou est le teleporteur pout y aller
	for( bonus_itr = Game_Manager.Bonus_List.begin() ; bonus_itr != Game_Manager.Bonus_List.end() ; bonus_itr++)
		if(  (*bonus_itr)->Type == TELEPORTEUR)
		{
			Px = (*bonus_itr)->Px;
			Py = (*bonus_itr)->Py;
			Game_Manager.Bonus_List.remove( (*bonus_itr) );
			Game_Manager.bTeleporteur_In_Game = false;
			return;
		}
	

	assert(0);  // il y a forcement un teleporteur ds la liste !!!!
}