/***************************************************************************************************/
/***************************************************************************************************/
//! \file player.h
//! \brief Dfini la du joueur
//!    
//!	Auteur : Adrien Auclair
//!
//! 
/***************************************************************************************************/
/***************************************************************************************************/
#ifndef PLAYER_H
#define PLAYER_H

/*------------------------------------  Prototypes  ---------------------------------------------*/
class cPlayer;

/*------------------------------------    Define    ---------------------------------------------*/
#define SPEED_WHITE_BALL 8
#define RAYON_WHITE_BALL 10
#define DELAY_BOMB 0.5
/*------------------------------------   Includes   ---------------------------------------------*/
#include "unit.h"



/*************************************************************************************************/
//! classe du joueur
/*! herite de cUnit car est une unit mobile circulaire \n
**************************************************************************************************/
class cPlayer : public cUnit
{
public :
	/// constructeur
	/**
	* x,y : position du joueur
	*/
	cPlayer(int x, int y);

	/// reagit au contact de la bombe 'bomb'
	void React_To_Bomb(cBomb * bomb);

	/// reagit au contact du cadeau 'cado'
	void React_To_Cadeau(cCadeau * cado);
	
	/// teleporte le joueur a l'endroit ou il y a le teleporteur courant de la zone de jeu
	void Use_Teleporteur();

	int Nb_Bombs;          ///< nb de bombes dont dispose le joueur
	int Nb_Hologrammes;    ///< nb d'hologrammes dont dispose le joueur
	int Nb_Teleporteurs;   ///< nb de teleporteurs dont dispose le joueur
	int Nb_Lives;          ///< nb de vies dont dispose le joueur
};


#endif