/***************************************************************************************************/
/***************************************************************************************************/
//! \file tests.h
//! \brief fonctions de tests
//!    
//!	Auteur : Adrien Auclair
//!
//! les fonctions de tests affichent sur sdt::cout leur resultat \n
//! pour l'instant seuls sont tests : \n
//! -> les intersections entre un segment quelconque et les murs du jeu \n
//! -> le pathfinder  \n
//!
//!
//! TODO : crer bcp plus de tests, notament pour tester le BSP \n
//!        les tests actuels sont loin tres exhaustifs..... (manque de temps)
//!
//! pour le pathfinder, on peut imaginer un algo de tests qui genere deux points au hasard
//! puis calcul le chemin entre les deux, et ensuite verifie que ce chemin ne coupe aucun mur.
//! cela testerait aussi les intersections avec les murs
//!
//! on pourrait aussi generer des niveaux aleatoires pour tester la construction du bsp
//! 
//!
//! il faudrait aussi crer des tests par comparaison de fichier textes  \n
//! cad on cre un fichier texte de reference ( comme resultat correct d'un algo  ) \n
//! l'algo  tester produit des resultats au format texte qui sont compars  la reference \n
//! cela permettrait de faire bcp plus de tests \n
/***************************************************************************************************/
/***************************************************************************************************/
#ifndef TESTS_H
#define TEST_H


/*-------------------------------------  Globals  -----------------------------------------------*/
//! test le module de pathfinding
extern void Test_Path_Finder();

//! test les intersections entre les walls et des segments quelconques
extern void Test_Intersections();


#endif